Package org.silverpeas.components.suggestionbox.notification

## Class AbstractSuggestionBoxUserNotification<T>

- java.lang.Object
- - org.silverpeas.core.notification.user.builder.AbstractUserNotificationBuilder
  - - org.silverpeas.core.notification.user.builder.AbstractResourceUserNotificationBuilder<T>
    - - org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder<T>
      - - org.silverpeas.components.suggestionbox.notification.AbstractSuggestionBoxUserNotification<T>

- Type Parameters:
    `T` - the type of resource concerned by the notification.
  All Implemented Interfaces:
    `org.silverpeas.core.notification.user.builder.UserNotificationBuilder`
  Direct Known Subclasses:
    `AbstractSuggestionUserNotification`

      public abstract class AbstractSuggestionBoxUserNotification<T>
      extends org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder<T>

  Author:
    Yohann Chastagnier

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder

      `org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder.NotificationTemporal`

  - ### Field Summary

    - ### Fields inherited from class org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder

      `CUSTOM_NOTIFICATION_SUBJECT, DEFAULT_NOTIFICATION_SUBJECT`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractSuggestionBoxUserNotification​(T resource)` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected String` | `getContributionAccessLinkLabelBundleKey()` |
    `protected String` | `getLocalizationBundlePath()` |
    `protected abstract org.silverpeas.core.admin.user.model.User` | `getSenderDetail()` | Gets the `UserDetail` instance of the sender.
    `protected String` | `getSenderName()` | Gets the name of the sender.
    `protected Collection<String>` | `getSuggestionBoxModerators()` | Gets the list of identifier of users that are moderators on the suggestion box.
    `protected String` | `getTemplatePath()` |

    - ### Methods inherited from class org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder

      `createNotification, getBundleSubjectKey, getTemplateFileName, getTitle, getTitle, perform, performBuild, performNotificationResource, performNotificationResource, performNotificationResource, performTemplateData`

    - ### Methods inherited from class org.silverpeas.core.notification.user.builder.AbstractResourceUserNotificationBuilder

      `getResource, getResourceURL, initialize, initializeNotificationResourceData, isGroupCanBeNotified, isSendImmediately, isUserCanBeNotified, performBuild, setResource`

    - ### Methods inherited from class org.silverpeas.core.notification.user.builder.AbstractUserNotificationBuilder

      `build, getAction, getBundle, getBundle, getComponentInstanceId, getContent, getExternalAddressesToNotify, getGroupIdsToNotify, getMessageType, getNotificationMetaData, getSender, getUserIdsToExcludeFromNotifying, getUserIdsToNotify, stop, stopWhenNoUserToNotify`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AbstractSuggestionBoxUserNotification

          public AbstractSuggestionBoxUserNotification​(T resource)

  - ### Method Detail

    - #### getLocalizationBundlePath

          protected String getLocalizationBundlePath()

      Overrides:
        `getLocalizationBundlePath` in class `org.silverpeas.core.notification.user.builder.AbstractUserNotificationBuilder`

    - #### getTemplatePath

          protected String getTemplatePath()

      Specified by:
        `getTemplatePath` in class `org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder<T>`

    - #### getSuggestionBoxModerators

          protected Collection<String> getSuggestionBoxModerators()

      Gets the list of identifier of users that are moderators on the suggestion box.
      Returns:
        identifier array of users.

    - #### getSenderName

          protected String getSenderName()

      Gets the name of the sender.
      Returns:

    - #### getSenderDetail

          protected abstract org.silverpeas.core.admin.user.model.User getSenderDetail()

      Gets the `UserDetail` instance of the sender.
      Returns:

    - #### getContributionAccessLinkLabelBundleKey

          protected String getContributionAccessLinkLabelBundleKey()

      Overrides:
        `getContributionAccessLinkLabelBundleKey` in class `org.silverpeas.core.notification.user.builder.AbstractTemplateUserNotificationBuilder<T>`